#include <iostream>
#include <cmath>
using namespace std;

int PGCD(int a,int b)
{   int r = a%b;
    while (r!=0)
    {   a = b ;
        b = r ;
        r = a%b;}
    return b; }

class Rational{
public:
    Rational(int num, int denom = 1)
    : num(num), denom(denom)
    {   int D = abs(PGCD(num,denom));
        if (D!=1) {this->num /= D, this->denom /= D;}}
    
    Rational add (const Rational& r) const
    {   Rational result(num*r.denom + r.num*denom , denom*r.denom);
        return result ;}
    Rational negate() const
    {   Rational result(-num,denom);
        return result ;}
    Rational substract (const Rational& r) const
    {   return (add(r.negate()));}
    Rational multiply (const Rational& r) const
    {   Rational result(num*r.num, denom*r.denom);
        return result; }
    
    void display() const
    {   cout << num << "/" << denom ; }
    
    
    //La surcharge des operateurs +, -, * et << permet d'ecrire plus facilement les fonctions add, substract, negate, multiply, et display
    
    Rational operator+ (const Rational& r) const
    {   Rational result(num*r.denom + r.num*denom , denom*r.denom);
        return result ;}
    Rational operator- () const
    {   Rational result(-num,-denom);
        return result ;}
    Rational operator- (const Rational& r) const
    {   return (add(r.negate()));}
    Rational operator* (const Rational& r) const
    {   Rational result(num*r.num, denom*r.denom);
        return result; }
    
    ostream& create_out(ostream& out) const
    {   out << num << "/" << denom;
        return out; }
    
private:
    int num;
    int denom;
};

//Cette fonction permet d'ecrire cout<<r

ostream& operator<<(ostream& out, const Rational& r)
{   return r.create_out(out) ;}

void displayEquation(Rational r1, Rational r2, char op)
{
    r1.display();
    cout << " " << op << " " ;
    r2.display();
    cout << " = " ;
    Rational result(0);
    if (op == '+')
    {   result = r1.add(r2);}
    else if (op == '-')
    {   result = r1.substract(r2);}
    else if (op == '*')
    {   result = r1.multiply(r2);}
    result.display();
    cout << endl;
}

void displayEquation_op(Rational r1, Rational r2, char op)
{
    cout << r1 << " " << op << " " << r2 << " = " ;
    Rational result(0);
    if (op == '+')
    {   result = r1+r2;}
    else if (op == '-')
    {   result = r1-r2;}
    else if (op == '*')
    {   result = r1*r2;}
    cout << result << endl;
}

int main()
{
    Rational r0(1,2);
    Rational r1(3);
    Rational r2 = r1.negate();
    Rational r3(1,4);
    
    displayEquation_op(r0, r2, '+');
    displayEquation_op(r0, r1, '-');
    displayEquation_op(r0, r1, '*');
    displayEquation_op(r0, r3, '+');
    return 0;
}
