#include <iostream>
#include <vector>
#include <string>
using namespace std;

class Student;
void displayName(const Student& student);

class Course{
public:
    Course(const string& name, int credits)
    :name(name), credits(credits) {}
    
    void setCredits(int cr)
    {   credits = cr;}
    
    string getName() const
    {   return name;}
    
    void add(const Student& student)
    {   students.push_back(&student);}
    
    void display() const
    {   cout << "Unite d'Enseignement (UE): " << name << ", credits: " << credits << endl;
        cout << "Etudiants inscrits: ";
        for(const Student* student:students)
        {
            displayName(*student); cout << " ";
        }
        cout << endl;}
    
private:
    string name;
    int credits;
    vector<const Student*> students;
};

class Student{
public:
    Student(string name)
    : name(name) {}
    
    string getName() const
    {   return name;}
    
    void add(Course& course)
    {   courses.push_back(&course);
        course.add(*this);}
    
    void display() const
    {   cout << "L'etudint " << name << " est inscrit dans: " << endl;
        for (const Course* course:courses)
        {   (*course).display();}
        cout << endl;}
    
private:
    string name;
    vector<const Course*> courses;
};


void displayName(const Student& student)
{   cout << student.getName(); }


int main()
{
    Course italien("Italien", 2);
    Course espagnol("Espagnol", 2);
    Course sport("Activite Spotive", 2);
    
    Student jean("Giovanni");
    jean.add(italien);
    jean.add(sport);
    
    italien.setCredits(4);
    
    Student paul("Pablo");
    paul.add(espagnol);
    paul.add(sport);
    
    espagnol.setCredits(4);
    sport.setCredits(3);
    
    jean.display();
    paul.display();
    
    return 0;
}
